Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Instances.Orienteering/3.3/Plugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Instances.Orienteering/3.3/Plugin.cs.frame	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Instances.Orienteering/3.3/Plugin.cs.frame	(revision 11307)
@@ -22,12 +22,8 @@
 using HeuristicLab.PluginInfrastructure;
 
-namespace HeuristicLab.Problems.Orienteering {
-  /// <summary>
-  /// Plugin class for HeuristicLab.Problems.Orienteering.
-  /// </summary>
+namespace HeuristicLab.Problems.Instances.Orienteering {
   [Plugin("HeuristicLab.Problems.Instances.Orienteering", "3.3.10.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.Instances.Orienteering-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
   public class HeuristicLabProblemsInstancesOrienteeringPlugin : PluginBase {    }
 }
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering.Views/3.3/Plugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering.Views/3.3/Plugin.cs.frame	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering.Views/3.3/Plugin.cs.frame	(revision 11307)
@@ -30,5 +30,12 @@
   [PluginDependency("HeuristicLab.Common", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Random", "3.3")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Problems.Orienteering", "3.3")]
   public class HeuristicLabProblemsOrienteeringViewsPlugin : PluginBase {    }
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Analyzers/BestOrienteeringSolutionAnalyser.cs
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Analyzers/BestOrienteeringSolutionAnalyser.cs	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Analyzers/BestOrienteeringSolutionAnalyser.cs	(revision 11307)
@@ -31,6 +31,6 @@
 
 namespace HeuristicLab.Problems.Orienteering {
-  public class BestOrienteeringSolutionAnalyser : SingleSuccessorOperator, IAnalyzer {
-    public virtual bool EnabledByDefault {
+  public sealed class BestOrienteeringSolutionAnalyser : SingleSuccessorOperator, IAnalyzer {
+    public bool EnabledByDefault {
       get { return true; }
     }
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Creators/GreedyOrienteeringTourCreator.cs
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Creators/GreedyOrienteeringTourCreator.cs	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Creators/GreedyOrienteeringTourCreator.cs	(revision 11307)
@@ -36,5 +36,5 @@
 points from this list at the first position in which they can feasibly be inserted. (Schilde et. al. 2009)")]
   [StorableClass]
-  public class GreedyOrienteeringTourCreator : IntegerVectorCreator {
+  public sealed class GreedyOrienteeringTourCreator : IntegerVectorCreator {
     public override bool CanChangeName { get { return false; } }
 
@@ -61,7 +61,7 @@
 
     [StorableConstructor]
-    protected GreedyOrienteeringTourCreator(bool deserializing)
+    private GreedyOrienteeringTourCreator(bool deserializing)
       : base(deserializing) { }
-    protected GreedyOrienteeringTourCreator(GreedyOrienteeringTourCreator original, Cloner cloner)
+    private GreedyOrienteeringTourCreator(GreedyOrienteeringTourCreator original, Cloner cloner)
       : base(original, cloner) { }
 
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Improvers/OrienteeringLocalImprovementOperator.cs
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Improvers/OrienteeringLocalImprovementOperator.cs	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Improvers/OrienteeringLocalImprovementOperator.cs	(revision 11307)
@@ -37,5 +37,5 @@
 minimize the cost of the tour. As shortening operator a 2-opt is applied. (Schilde et. al. 2009)")]
   [StorableClass]
-  public class OrienteeringLocalImprovementOperator : SingleSuccessorOperator, ILocalImprovementOperator {
+  public sealed class OrienteeringLocalImprovementOperator : SingleSuccessorOperator, ILocalImprovementOperator {
 
     #region Parameter Properties
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblem.cs
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblem.cs	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblem.cs	(revision 11307)
@@ -38,5 +38,5 @@
   [Creatable("Problems")]
   [StorableClass]
-  public class OrienteeringProblem
+  public sealed class OrienteeringProblem
     : SingleObjectiveHeuristicOptimizationProblem<IOrienteeringEvaluator, IIntegerVectorCreator>,
     IStorableContent, IProblemInstanceConsumer<OPData>, IProblemInstanceConsumer<TSPData>, IProblemInstanceConsumer<CVRPData> {
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs	(revision 11307)
@@ -10,5 +10,5 @@
   [Item("OrienteeringSolution", "Represents a Orienteering solution which can be visualized in the GUI.")]
   [StorableClass]
-  public class OrienteeringSolution : Item {
+  public sealed class OrienteeringSolution : Item {
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Image; }
@@ -95,5 +95,6 @@
 
     [StorableConstructor]
-    private OrienteeringSolution(bool deserializing) : base(deserializing) { }
+    private OrienteeringSolution(bool deserializing)
+      : base(deserializing) { }
     private OrienteeringSolution(OrienteeringSolution original, Cloner cloner)
       : base(original, cloner) {
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Plugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Plugin.cs.frame	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Plugin.cs.frame	(revision 11307)
@@ -28,6 +28,16 @@
   [Plugin("HeuristicLab.Problems.Orienteering", "3.3.10.$WCREV$")]
   [PluginFile("HeuristicLab.Problems.Orienteering-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
   [PluginDependency("HeuristicLab.Random", "3.3")]
   [PluginDependency("HeuristicLab.Scripting", "3.3")]
Index: /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs
===================================================================
--- /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs	(revision 11306)
+++ /branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs	(revision 11307)
@@ -46,5 +46,5 @@
 (Schilde et. al. 2009)")]
   [StorableClass]
-  public class OrienteeringShakingOperator : SingleSuccessorOperator, IMultiNeighborhoodShakingOperator, IStochasticOperator {
+  public sealed class OrienteeringShakingOperator : SingleSuccessorOperator, IMultiNeighborhoodShakingOperator, IStochasticOperator {
 
     #region Shaking Parameter Properties