Index: branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Analyzers/BestOrienteeringSolutionAnalyser.cs
===================================================================
--- branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Analyzers/BestOrienteeringSolutionAnalyser.cs	(revision 11316)
+++ branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Analyzers/BestOrienteeringSolutionAnalyser.cs	(revision 11319)
@@ -45,6 +45,6 @@
       get { return (ILookupParameter<IntValue>)Parameters["StartingPoint"]; }
     }
-    public ILookupParameter<IntValue> TerminusPointParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["TerminusPoint"]; }
+    public ILookupParameter<IntValue> TerminalPointParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["TerminalPoint"]; }
     }
     public ILookupParameter<DoubleArray> ScoresParameter {
@@ -85,5 +85,5 @@
       Parameters.Add(new LookupParameter<DoubleMatrix>("Coordinates", "The x- and y-Coordinates of the points."));
       Parameters.Add(new LookupParameter<IntValue>("StartingPoint", "Index of the starting point."));
-      Parameters.Add(new LookupParameter<IntValue>("TerminusPoint", "Index of the ending point."));
+      Parameters.Add(new LookupParameter<IntValue>("TerminalPoint", "Index of the ending point."));
       Parameters.Add(new LookupParameter<DoubleArray>("Scores", "The scores of the points."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the Orienteering solutions which should be analyzed."));
@@ -114,5 +114,5 @@
       var coordinates = CoordinatesParameter.ActualValue;
       var startingPoint = StartingPointParameter.ActualValue;
-      var terminusPoint = TerminusPointParameter.ActualValue;
+      var terminalPoint = TerminalPointParameter.ActualValue;
       var scores = ScoresParameter.ActualValue;
       if (solution == null) {
@@ -121,5 +121,5 @@
           coordinates,
           startingPoint,
-          terminusPoint,
+          terminalPoint,
           scores,
           new DoubleValue(qualities[bestIndex].Value),
Index: branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Creators/GreedyOrienteeringTourCreator.cs
===================================================================
--- branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Creators/GreedyOrienteeringTourCreator.cs	(revision 11316)
+++ branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Creators/GreedyOrienteeringTourCreator.cs	(revision 11319)
@@ -52,6 +52,6 @@
       get { return (ILookupParameter<IntValue>)Parameters["StartingPoint"]; }
     }
-    public ILookupParameter<IntValue> TerminusPointParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["TerminusPoint"]; }
+    public ILookupParameter<IntValue> TerminalPointParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["TerminalPoint"]; }
     }
     public ILookupParameter<DoubleValue> FixedPenaltyParameter {
@@ -72,5 +72,5 @@
       Parameters.Add(new LookupParameter<DoubleValue>("MaximumDistance", "The maximum distance constraint for a Orienteering solution."));
       Parameters.Add(new LookupParameter<IntValue>("StartingPoint", "Index of the starting point."));
-      Parameters.Add(new LookupParameter<IntValue>("TerminusPoint", "Index of the ending point."));
+      Parameters.Add(new LookupParameter<IntValue>("TerminalPoint", "Index of the ending point."));
       Parameters.Add(new LookupParameter<DoubleValue>("FixedPenalty", "The penalty for each visited vertex."));
     }
@@ -82,5 +82,5 @@
     protected override IntegerVector Create(IRandom _, IntValue __, IntMatrix ___) {
       int startPoint = StartingPointParameter.ActualValue.Value;
-      int endPoint = TerminusPointParameter.ActualValue.Value;
+      int endPoint = TerminalPointParameter.ActualValue.Value;
       int numPoints = ScoresParameter.ActualValue.Length;
       var distances = DistanceMatrixParameter.ActualValue;
Index: branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Improvers/OrienteeringLocalImprovementOperator.cs
===================================================================
--- branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Improvers/OrienteeringLocalImprovementOperator.cs	(revision 11316)
+++ branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Improvers/OrienteeringLocalImprovementOperator.cs	(revision 11319)
@@ -55,6 +55,6 @@
       get { return (ILookupParameter<IntValue>)Parameters["StartingPoint"]; }
     }
-    public ILookupParameter<IntValue> TerminusPointParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["TerminusPoint"]; }
+    public ILookupParameter<IntValue> TerminalPointParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["TerminalPoint"]; }
     }
     public ILookupParameter<DoubleValue> FixedPenaltyParameter {
@@ -98,5 +98,5 @@
       Parameters.Add(new LookupParameter<DoubleValue>("MaximumDistance", "The maximum distance constraint for a Orienteering solution."));
       Parameters.Add(new LookupParameter<IntValue>("StartingPoint", "Index of the starting point."));
-      Parameters.Add(new LookupParameter<IntValue>("TerminusPoint", "Index of the ending point."));
+      Parameters.Add(new LookupParameter<IntValue>("TerminalPoint", "Index of the ending point."));
       Parameters.Add(new LookupParameter<DoubleValue>("FixedPenalty", "The penalty for each visited vertex."));
 
Index: branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblem.cs	(revision 11316)
+++ branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblem.cs	(revision 11319)
@@ -55,6 +55,6 @@
       get { return (ValueParameter<IntValue>)Parameters["StartingPoint"]; }
     }
-    public ValueParameter<IntValue> TerminusPointParameter {
-      get { return (ValueParameter<IntValue>)Parameters["TerminusPoint"]; }
+    public ValueParameter<IntValue> TerminalPointParameter {
+      get { return (ValueParameter<IntValue>)Parameters["TerminalPoint"]; }
     }
     public ValueParameter<DoubleValue> MaximumDistanceParameter {
@@ -86,7 +86,7 @@
       set { StartingPointParameter.Value = value; }
     }
-    public IntValue TerminusPoint {
-      get { return TerminusPointParameter.Value; }
-      set { TerminusPointParameter.Value = value; }
+    public IntValue TerminalPoint {
+      get { return TerminalPointParameter.Value; }
+      set { TerminalPointParameter.Value = value; }
     }
     public DoubleValue MaximumDistance {
@@ -127,5 +127,5 @@
       Parameters.Add(new ValueParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the points."));
       Parameters.Add(new ValueParameter<IntValue>("StartingPoint", "Index of the starting point.", new IntValue(0)));
-      Parameters.Add(new ValueParameter<IntValue>("TerminusPoint", "Index of the ending point.", new IntValue(0)));
+      Parameters.Add(new ValueParameter<IntValue>("TerminalPoint", "Index of the ending point.", new IntValue(0)));
       Parameters.Add(new ValueParameter<DoubleValue>("MaximumDistance", "The maximum distance constraint for a Orienteering solution."));
       Parameters.Add(new ValueParameter<DoubleArray>("Scores", "The scores of the points."));
@@ -186,5 +186,5 @@
     }
 
-    private void TerminusPointParameter_ValueChanged(object sender, EventArgs e) {
+    private void TerminalPointParameter_ValueChanged(object sender, EventArgs e) {
       ParameterizeEvaluator();
       ParameterizeAnalyzer();
@@ -226,5 +226,5 @@
 
       StartingPointParameter.ValueChanged += StartingPointParameter_ValueChanged;
-      TerminusPointParameter.ValueChanged += TerminusPointParameter_ValueChanged;
+      TerminalPointParameter.ValueChanged += TerminalPointParameter_ValueChanged;
       MaximumDistanceParameter.ValueChanged += MaximumDistanceParameter_ValueChanged;
 
@@ -241,5 +241,5 @@
         creator.MaximumDistanceParameter.ActualName = MaximumDistanceParameter.Name;
         creator.StartingPointParameter.ActualName = StartingPointParameter.Name;
-        creator.TerminusPointParameter.ActualName = TerminusPointParameter.Name;
+        creator.TerminalPointParameter.ActualName = TerminalPointParameter.Name;
         creator.FixedPenaltyParameter.ActualName = FixedPenaltyParameter.Name;
       }
@@ -280,5 +280,5 @@
         op.MaximumDistanceParameter.ActualName = MaximumDistanceParameter.Name;
         op.StartingPointParameter.ActualName = StartingPointParameter.Name;
-        op.TerminusPointParameter.ActualName = TerminusPointParameter.Name;
+        op.TerminalPointParameter.ActualName = TerminalPointParameter.Name;
         op.FixedPenaltyParameter.ActualName = FixedPenaltyParameter.Name;
       }
@@ -289,5 +289,5 @@
         op.MaximumDistanceParameter.ActualName = MaximumDistanceParameter.Name;
         op.StartingPointParameter.ActualName = StartingPointParameter.Name;
-        op.TerminusPointParameter.ActualName = TerminusPointParameter.Name;
+        op.TerminalPointParameter.ActualName = TerminalPointParameter.Name;
         op.FixedPenaltyParameter.ActualName = FixedPenaltyParameter.Name;
       }
@@ -334,5 +334,5 @@
 
       StartingPoint.Value = 0;
-      TerminusPoint.Value = 20;
+      TerminalPoint.Value = 20;
       MaximumDistance.Value = 30;
 
@@ -360,5 +360,5 @@
 
       StartingPoint = new IntValue(data.StartingPoint);
-      TerminusPoint = new IntValue(data.TerminusPoint);
+      TerminalPoint = new IntValue(data.TerminalPoint);
 
       MaximumDistance = new DoubleValue(data.MaximumDistance);
@@ -386,5 +386,5 @@
 
       StartingPoint = new IntValue(0); // First city is interpreted as start point
-      TerminusPoint = new IntValue(data.Dimension - 1); // Last city is interpreted als end point
+      TerminalPoint = new IntValue(data.Dimension - 1); // Last city is interpreted als end point
 
       MaximumDistance = new DoubleValue(DistanceMatrix.Average() * 5.0); // distance from start to end first to last city is interpreted as maximum distance
@@ -411,5 +411,5 @@
 
       StartingPoint = new IntValue(0); // Depot is interpreted as start point
-      TerminusPoint = new IntValue(0); // Depot is interpreted als end point
+      TerminalPoint = new IntValue(0); // Depot is interpreted als end point
 
       MaximumDistance = new DoubleValue(data.Capacity * 2); // capacity is interpreted as max distance
Index: branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs
===================================================================
--- branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs	(revision 11316)
+++ branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs	(revision 11319)
@@ -55,13 +55,13 @@
     }
     [Storable]
-    private IntValue terminusPoint;
-    public IntValue TerminusPoint {
-      get { return terminusPoint; }
-      set {
-        if (terminusPoint != value) {
-          if (terminusPoint != null) DeregisterTerminusPointEvents();
-          terminusPoint = value;
-          if (terminusPoint != null) RegisterTerminusPointEvents();
-          OnTerminusPointChanged();
+    private IntValue terminalPoint;
+    public IntValue TerminalPoint {
+      get { return terminalPoint; }
+      set {
+        if (terminalPoint != value) {
+          if (terminalPoint != null) DeregisterTerminalPointEvents();
+          terminalPoint = value;
+          if (terminalPoint != null) RegisterTerminalPointEvents();
+          OnTerminalPointChanged();
         }
       }
@@ -118,5 +118,5 @@
       Initialize();
     }
-    public OrienteeringSolution(IntegerVector integerVector, DoubleMatrix coordinates, IntValue startingPoint, IntValue terminusPoint,
+    public OrienteeringSolution(IntegerVector integerVector, DoubleMatrix coordinates, IntValue startingPoint, IntValue terminalPoint,
       DoubleArray scores, DoubleValue quality, DoubleValue penalty)
       : base() {
@@ -124,5 +124,5 @@
       this.coordinates = coordinates;
       this.startingPoint = startingPoint;
-      this.terminusPoint = terminusPoint;
+      this.terminalPoint = terminalPoint;
       this.scores = scores;
       this.quality = quality;
@@ -144,5 +144,5 @@
       if (coordinates != null) RegisterCoordinatesEvents();
       if (startingPoint != null) RegisterStartingPointEvents();
-      if (terminusPoint != null) RegisterTerminusPointEvents();
+      if (terminalPoint != null) RegisterTerminalPointEvents();
       if (scores != null) RegisterScoresEvents();
       if (quality != null) RegisterQualityEvents();
@@ -172,7 +172,7 @@
     }
 
-    public event EventHandler TerminusPointChanged;
-    private void OnTerminusPointChanged() {
-      var changed = TerminusPointChanged;
+    public event EventHandler TerminalPointChanged;
+    private void OnTerminalPointChanged() {
+      var changed = TerminalPointChanged;
       if (changed != null)
         changed(this, EventArgs.Empty);
@@ -222,9 +222,9 @@
       StartingPoint.ValueChanged -= new EventHandler(StartingPoint_ValueChanged);
     }
-    private void RegisterTerminusPointEvents() {
-      TerminusPoint.ValueChanged += new EventHandler(TerminusPoint_ValueChanged);
-    }
-    private void DeregisterTerminusPointEvents() {
-      TerminusPoint.ValueChanged -= new EventHandler(TerminusPoint_ValueChanged);
+    private void RegisterTerminalPointEvents() {
+      TerminalPoint.ValueChanged += new EventHandler(TerminalPoint_ValueChanged);
+    }
+    private void DeregisterTerminalPointEvents() {
+      TerminalPoint.ValueChanged -= new EventHandler(TerminalPoint_ValueChanged);
     }
     private void RegisterScoresEvents() {
@@ -264,6 +264,6 @@
       OnStartingPointChanged();
     }
-    private void TerminusPoint_ValueChanged(object sender, EventArgs e) {
-      OnTerminusPointChanged();
+    private void TerminalPoint_ValueChanged(object sender, EventArgs e) {
+      OnTerminalPointChanged();
     }
     private void Scores_ItemChanged(object sender, EventArgs<int> e) {
Index: branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs
===================================================================
--- branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs	(revision 11316)
+++ branches/HeuristicLab.Problems.Orienteering/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs	(revision 11319)
@@ -67,6 +67,6 @@
       get { return (ILookupParameter<IntValue>)Parameters["StartingPoint"]; }
     }
-    public ILookupParameter<IntValue> TerminusPointParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["TerminusPoint"]; }
+    public ILookupParameter<IntValue> TerminalPointParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["TerminalPoint"]; }
     }
     public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
@@ -98,5 +98,5 @@
       Parameters.Add(new LookupParameter<DoubleValue>("MaximumDistance", "The maximum distance constraint for a Orienteering solution."));
       Parameters.Add(new LookupParameter<IntValue>("StartingPoint", "Index of the starting point."));
-      Parameters.Add(new LookupParameter<IntValue>("TerminusPoint", "Index of the ending point."));
+      Parameters.Add(new LookupParameter<IntValue>("TerminalPoint", "Index of the ending point."));
       Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the points."));
       Parameters.Add(new LookupParameter<DoubleArray>("Scores", "The scores of the points."));
@@ -115,5 +115,5 @@
       var scores = ScoresParameter.ActualValue;
       var startingPoint = StartingPointParameter.ActualValue.Value;
-      var terminusPoint = TerminusPointParameter.ActualValue.Value;
+      var terminalPoint = TerminalPointParameter.ActualValue.Value;
       var fixedPenalty = FixedPenaltyParameter.ActualValue.Value;
       double maxDistance = MaximumDistanceParameter.ActualValue.Value;
@@ -139,7 +139,7 @@
           from point in Enumerable.Range(0, numPoints)
           // Calculate the distance when going from the starting point to this point and then to the end point
-          let distance = distances[startingPoint, point] + distances[point, terminusPoint] + fixedPenalty
+          let distance = distances[startingPoint, point] + distances[point, terminalPoint] + fixedPenalty
           // If this distance is feasible and the point is neither starting nor ending point, check the point
-          where distance < maxDistance && point != startingPoint && point != terminusPoint
+          where distance < maxDistance && point != startingPoint && point != terminalPoint
           // The point was not yet visited, so add it to the candidate list
           where !initialTour.Contains(point)